"use strict";
exports.__esModule = true;
var Range = require("../range");
var Position = require("../pos");
var Ast = require("../ast");
var Patch = require("../patch");
var fixer = {
    suggestCodeAction: function (params) {
        var j = params.j, ast = params.ast;
        var node = Ast.findLastNode(ast, j.ReturnStatement, function (n) { return n.loc !== null && Range.isInside(params.selection, n.loc); });
        if (!node || !node.loc || !node.argument) {
            return null;
        }
        return {
            title: "Extract return argument",
            data: node.loc.start
        };
    },
    createEdit: function (params) {
        var data = params.data, ast = params.ast, j = params.j;
        var node = Ast.findFirstNode(ast, j.ReturnStatement, function (n) { return Ast.isOnPosition(n, data); });
        if (!node) {
            return null;
        }
        var arg = node.argument;
        if (!arg) {
            return null;
        }
        var varName = 'result';
        var id = j.identifier(varName);
        var declarator = j.variableDeclarator(id, arg);
        var declaraion = j.variableDeclaration('const', [declarator]);
        var newNode = j.returnStatement(id);
        var loc = node.loc;
        if (!loc) {
            return null;
        }
        return [
            Patch.replaceNode(j, node, newNode),
            Patch.insert(j, Position.create(loc.start.line, loc.start.column), [declaraion, '\n\n']),
        ];
    }
};
exports["default"] = fixer;
